"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addOptions = exports.getSidebarOptions = exports.getTypedocOptions = void 0;
const typedoc_1 = require("typedoc");
const DEFAULT_TYPEDOC_OPTIONS = {
    out: 'api',
    plugin: ['none'],
    hideBreadcrumbs: true,
    theme: 'vuepress',
};
const DEFAULT_SIDEBAR_OPTIONS = {
    parentCategory: 'API',
    fullNames: false,
    autoConfiguration: true,
};
const getTypedocOptions = (opts) => {
    const options = {
        ...DEFAULT_TYPEDOC_OPTIONS,
        ...opts,
    };
    return options;
};
exports.getTypedocOptions = getTypedocOptions;
const getSidebarOptions = (opts) => {
    const options = {
        ...DEFAULT_SIDEBAR_OPTIONS,
        ...opts.sidebar,
    };
    return options;
};
exports.getSidebarOptions = getSidebarOptions;
const addOptions = (app) => {
    app.options.addReader(new typedoc_1.TypeDocReader());
    app.options.addReader(new typedoc_1.TSConfigReader());
};
exports.addOptions = addOptions;
